import std.stdio;

import clock;

import teststatic;
import testclass;
import teststandard;
import testdynamic;
import testdynamicindirect;

int main(string[] args)
{
	uint testCount = 400000000;
	uint lapCount = 3;
	
	uint staticTime, classTime, standardTime, dynamicTime, dynamicIndirectTime;
	
	for (int i; i < lapCount; ++i)
	{
		writefln("== Lap %d of %d; testing %d function calls ==", i+1, lapCount, testCount);
		int result, base;
		
		writef("Static:           ");
		result = testStatic(testCount);
		staticTime += result;
		printClock(result);
		base = result;
		
		writef("D Class:          ");
		result = testClass(testCount);
		classTime += result;
		printClockCompare(result, base);
		
		writef("Standard:         ");
		result = testStandard(testCount);
		standardTime += result;
		printClockCompare(result, base);
		
		writef("Dynamic:          ");
		result = testDynamic(testCount);
		dynamicTime += result;
		printClockCompare(result, base);
		
		writef("Dynamic Indirect: ");
		result = testDynamicIndirect(testCount);
		dynamicIndirectTime += result;
		printClockCompare(result, base);
	}
	writefln("== %d-lap average; totaling %d function calls ==", 
		lapCount, testCount*lapCount);
	
	writefln("Static:           %d ticks; %f (base time)", staticTime/lapCount, 1.0);
	writefln("D class:          %d ticks; %f", classTime/lapCount, cast(float)classTime / staticTime);
	writefln("Standard:         %d ticks; %f", standardTime/lapCount, cast(float)standardTime / staticTime);
	writefln("Dynamic:          %d ticks; %f", dynamicTime/lapCount, cast(float)dynamicTime / staticTime);
	writefln("Dynamic Indirect: %d ticks; %f", dynamicIndirectTime/lapCount, cast(float)dynamicIndirectTime / staticTime);
	
	return 0;
}
