#include "testdynamic.h"
#include "clock.h"
#include <cstdio>

namespace TestDynamic
{
	struct VTable;

	struct TestObject
	{
		VTable * vtable;
	};

	struct VTable
	{
		void (*vcall[2])(TestObject *);
	};

	static void vcallImplementation(TestObject * object)
	{
		
	}

	static unsigned int callOffset;

	static TestObject * create()
	{
		TestObject * object = new TestObject;
		object->vtable = new VTable;
		object->vtable->vcall[1] = &vcallImplementation;
		callOffset = 1;
		return object;
	}
}

unsigned int testDynamic(unsigned testCount)
{
	using namespace TestDynamic;
	
	TestObject* object = create();
	startClock();
	for (unsigned i = 0; i < testCount; ++i)
		object->vtable->vcall[callOffset](object);
	return currentClock();
}
